﻿@using Microsoft.Extensions.Localization
@using Newtonsoft.Json
@using OTaskForce.Singletons
@using ElectronNET.API
@using System.IO
@using System.Text
@using Overtest.SharedLibraries.ProgrammingTasksShared.VerificationData

@inject IJSRuntime _jsRuntime
@inject NavigationManager _navigationManager
@inject IStringLocalizer<VerificationDataEditor> _localizer
@inject ProjectsOperator _projectsOperator

<section class="position-absolute p-3" style="top: 0; bottom: 0; left: 0; right: 0; overflow-y: auto;">
    @if (_configuration == null)
    {
        <div class="alert alert-dark">@_localizer["Зачекайте, дані завантажуються..."]</div>
    }
    else
    {
        <EditForm Model="_configuration" OnValidSubmit="@(async () => await HandleValidSubmitAsync())" OnInvalidSubmit="@HandleInvalidSubmit">
            <DataAnnotationsValidator/>

            @* Global configuration *@
            <div class="mb-3">
                @* SchemaVersion *@
                <div class="form-floating mb-0">
                    <InputNumber @bind-Value="@_configuration.SchemaVersion" class="form-control" readonly/>
                    <label>@_localizer["Версія конфігураційного файлу ({0})", nameof(_configuration.SchemaVersion)]</label>
                </div>
                @* /SchemaVersion *@
            </div>
            @* /Global configuration *@

            @* AuthorSolution *@
            <div class="card border border-secondary mt-0 mb-3">
                <h5 class="card-header bg-light bg-gradient text-dark">@_localizer["Авторський розв'язок"]</h5>
                <div class="card-body">
                    @* AuthorSolution.CompilerId *@
                    <div class="form-floating mt-0">
                        <InputText @bind-Value="@_configuration.AuthorSolution.CompilerId" class="form-control"/>
                        <label>@_localizer["Ідентифікатор компілятора ({0})", nameof(_configuration.AuthorSolution.CompilerId)]</label>
                        <div class="form-text">@_localizer["Вкажіть ідентифікатор типу Guid, який відповідає мові програмування, якою написано авторський розв'язок до завдання. Його можна переглянути у розділі \"Адміністрування\" -> \"Управління компіляторами\" вебзастосунку."]</div>
                    </div>
                    @* /AuthorSolution.CompilerId *@

                    @* AuthorSolution.SourceCodePath *@
                    <div class="form-floating mt-2">
                        <label>@_localizer["Директорія з авторським розв'язком ({0})", nameof(_configuration.AuthorSolution.SourceCodePath)]</label>
                        <div class="input-group">
                            <InputText @bind-Value="@_configuration.AuthorSolution.SourceCodePath" class="form-control"/>
                            <button type="button" class="btn btn-outline-secondary" @onclick="@(async () => await ExecuteCreateAndOpenAsync(CreateObjectType.AuthorSolutionDirectory))">
                                <i class="fas fa-folder-open"></i>
                            </button>
                        </div>
                        <div class="form-text">@_localizer["Вкажіть відносний шлях до директорії з файлами сирцевого коду авторського розв'язку, який буде використовуватися при перевірці розв'язків інших користувачів."]</div>
                    </div>
                    @* /AuthorSolution.SourceCodePath *@
                </div>
            </div>
            @* /AuthorSolution *@

            @* TestLib *@
            <div class="card border border-secondary mt-3 mb-3">
                <h5 class="card-header bg-light bg-gradient text-dark">@_localizer["Бібліотека тестування"]</h5>
                <div class="card-body">
                    @* TestLib.InitializerPath *@
                    <div class="mt-0">
                        <label>@_localizer["Ініціалізатор ({0})", nameof(_configuration.TestLib.InitializerPath)]</label>
                        <div class="input-group">
                            <InputText @bind-Value="@_configuration.TestLib.InitializerPath" class="form-control"/>
                            <button type="button" class="btn btn-outline-secondary" @onclick="@(async () => await ExecuteCreateAndOpenAsync(CreateObjectType.InitializerFile))">
                                <i class="fas fa-file-alt"></i>
                            </button>
                        </div>
                        <div class="form-text">@_localizer["Вкажіть відносний шлях до скрипта-ініціалізатора."]</div>
                    </div>
                    @* /TestLib.InitializerPath *@

                    @* TestLib.FinalizerPath *@
                    <div class="mt-2">
                        <label>@_localizer["Фіналізатор ({0})", nameof(_configuration.TestLib.FinalizerPath)]</label>
                        <div class="input-group">
                            <InputText @bind-Value="@_configuration.TestLib.FinalizerPath" class="form-control"/>
                            <button type="button" class="btn btn-outline-secondary" @onclick="@(async () => await ExecuteCreateAndOpenAsync(CreateObjectType.FinalizerFile))">
                                <i class="fas fa-file-alt"></i>
                            </button>
                        </div>
                        <div class="form-text">@_localizer["Вкажіть відносний шлях до скрипта-фіналізатора."]</div>
                    </div>
                    @* /TestLib.FinalizerPath *@

                    @* TestLib.GeneratorPath *@
                    <div class="mt-2">
                        <label>@_localizer["Генератор ({0})", nameof(_configuration.TestLib.GeneratorPath)]</label>
                        <div class="input-group">
                            <InputText @bind-Value="@_configuration.TestLib.GeneratorPath" class="form-control"/>
                            <button type="button" class="btn btn-outline-secondary" @onclick="@(async () => await ExecuteCreateAndOpenAsync(CreateObjectType.GeneratorFile))">
                                <i class="fas fa-file-alt"></i>
                            </button>
                        </div>
                        <div class="form-text">@_localizer["Вкажіть відносний шлях до генератора тестів."]</div>
                    </div>
                    @* /TestLib.GeneratorPath *@

                    @* TestLib.CheckerPath *@
                    <div class="mt-2">
                        <label>@_localizer["Чекер ({0})", nameof(_configuration.TestLib.CheckerPath)]</label>
                        <div class="input-group">
                            <InputText @bind-Value="@_configuration.TestLib.CheckerPath" class="form-control"/>
                            <button type="button" class="btn btn-outline-secondary" @onclick="@(async () => await ExecuteCreateAndOpenAsync(CreateObjectType.CheckerFile))">
                                <i class="fas fa-file-alt"></i>
                            </button>
                        </div>
                        <div class="form-text">@_localizer["Вкажіть відносний шлях до програми-чекера."]</div>
                    </div>
                    @* /TestLib.CheckerPath *@

                    <h5 class="mt-2">@_localizer["Переспрямування потоків"]</h5>

                    @* TestLib.DefaultInputFileName *@
                    <div class="form-floating mt-2">
                        <InputText @bind-Value="@_configuration.TestLib.DefaultInputFileName" class="form-control"/>
                        <label>@_localizer["Назва файлу зі вхідними даними ({0})", nameof(_configuration.TestLib.DefaultInputFileName)]</label>
                        <div class="form-text">@_localizer["Вкажіть ім'я файлу, що буде знаходитися у директорії з тестованою програмою, дані з якого слід направити у вхідний потік програми."]</div>
                    </div>
                    @* /TestLib.DefaultInputFileName *@

                    @* TestLib.DefaultInputFileName *@
                    <div class="form-floating mt-2">
                        <InputText @bind-Value="@_configuration.TestLib.DefaultOutputFileName" class="form-control"/>
                        <label>@_localizer["Назва файлу з вихідними даними ({0})", nameof(_configuration.TestLib.DefaultOutputFileName)]</label>
                        <div class="form-text">@_localizer["Вкажіть ім'я файлу, у який слід записати вихідні дані тестованої програми. Якщо файл з такою назвою існуватиме, його буде перезаписано."]</div>
                    </div>
                    @* /TestLib.DefaultInputFileName *@
                </div>
            </div>
            @* /TestLib *@

            @* RuntimeLimits *@
            <div class="card border border-secondary mt-3 mb-3">
                <h5 class="card-header bg-light bg-gradient text-dark">@_localizer["Обмеження ресурсів"]</h5>
                <div class="card-body">
                    <p>@_localizer["Обмеження ресурсів, вказані у цьому розділі, застосовуються до режиму тестування \"Зневадження\" (Debug mode), а також слугують обмеженнями за замовчуванням для усіх тестів (перевірок) у режимі остаточного тестування і оцінки (Release mode)."]</p>

                    @* RuntimeLimits.MaxRealTime *@
                    <div class="form-floating mt-2">
                        <InputNumber @bind-Value="@_configuration.RuntimeLimits.MaxRealTime" class="form-control"/>
                        <label>@_localizer["Обмеження астрономічного часу ({0})", nameof(_configuration.RuntimeLimits.MaxRealTime)]</label>
                        <div class="form-text">@_localizer["Вкажіть максимальний астрономічний час виконання програми користувача у мілісекундах, після вичерпання якого процес примусово завершує свою роботу."]</div>
                    </div>
                    @* /RuntimeLimits.MaxRealTime *@

                    @* RuntimeLimits.MaxProcessorTime *@
                    <div class="form-floating mt-2">
                        <InputNumber @bind-Value="@_configuration.RuntimeLimits.MaxProcessorTime" class="form-control"/>
                        <label>@_localizer["Обмеження процесорного часу ({0})", nameof(_configuration.RuntimeLimits.MaxProcessorTime)]</label>
                        <div class="form-text">@_localizer["Вкажіть максимальний процесорний час виконання програми користувача у мілісекундах, після вичерпання якого процес примусово завершує свою роботу."]</div>
                    </div>
                    @* /RuntimeLimits.MaxProcessorTime *@

                    @* RuntimeLimits.PeakWorkingSet *@
                    <div class="form-floating mt-2">
                        <InputNumber @bind-Value="@_configuration.RuntimeLimits.PeakWorkingSet" class="form-control"/>
                        <label>@_localizer["Обмеження використання пам'яті ({0})", nameof(_configuration.RuntimeLimits.PeakWorkingSet)]</label>
                        <div class="form-text">@_localizer["Вкажіть обмеження використання віртуальної пам'яті (working set) у байтах процесом, у випадку порушення якого процес примусово завершує свою роботу."]</div>
                    </div>
                    @* /RuntimeLimits.PeakWorkingSet *@
                </div>
            </div>
            @* RuntimeLimits *@

            @* ReleaseConfiguration *@
            <div class="card border border-secondary mt-3 mb-0">
                <h5 class="card-header bg-light bg-gradient text-dark">@_localizer["Режим перевірки"]</h5>
                <div class="card-body">
                    @* ReleaseConfiguration.RealTimeKillsLimit *@
                    <div class="form-floating mt-0">
                        <InputNumber @bind-Value="@_configuration.ReleaseConfiguration.RealTimeKillsLimit" class="form-control"/>
                        <label>@_localizer["Обмеження надмірного очікування ({0})", nameof(_configuration.ReleaseConfiguration.RealTimeKillsLimit)]</label>
                        <div class="form-text">@_localizer["Вкажіть максимальну кількість тестів, на яких програма користувача може перевищити обмеження по кількості використаного австрономічного часу, після досягнення якої тестування розв'язку буде доструково припинено."]</div>
                    </div>
                    @* /ReleaseConfiguration.RealTimeKillsLimit *@

                    <div>
                        <div class="d-flex justify-content-between my-2">
                            <h5 class="m-0 align-self-center">@_localizer["Тести"]</h5>
                            <button type="button" class="btn btn-sm btn-success" @onclick="@CreateNewReleaseTest"><i class="fas fa-plus-circle"></i> @_localizer["Новий тест"]</button>
                        </div>

                        @if (_configuration is { ReleaseConfiguration: { Tests: { } } } && _configuration.ReleaseConfiguration.Tests.Any())
                        {
                            var currentTestIdIter = 0;

                            <div class="accordion accordion-flush">
                                @foreach (var testInfo in _configuration.ReleaseConfiguration.Tests)
                                {
                                    currentTestIdIter++;
                                    var currentTestId = currentTestIdIter;

                                    <div class="accordion-item">
                                        <h2 class="accordion-header">
                                            <button class="accordion-button px-0 py-2 collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#test-edit-@currentTestId">
                                                @_localizer["Налаштування тесту №{0}", currentTestId]
                                            </button>
                                        </h2>
                                        <div id="test-edit-@currentTestId" class="accordion-collapse collapse">
                                            <div class="accordion-body px-0">
                                                @* Test title *@
                                                <div class="form-floating mt-2">
                                                    <InputText @bind-Value="@testInfo.Title" class="form-control"/>
                                                    <label>@_localizer["Назва тесту ({0})", nameof(testInfo.Title)]</label>
                                                    <div class="form-text">@_localizer["Назва тесту відображається на сторінці результатів тестування. Вигадайте таку назву, яка буде зрозумілою користувачу. Наприклад: \"Перевірка на від'ємних значеннях\"."]</div>
                                                </div>
                                                @* /Test title *@
                                                
                                                <div class="form-check form-switch mt-2">
                                                    <label class="form-check-label">
                                                        <InputCheckbox @bind-Value="@testInfo.ExecuteAuthorSolution" class="form-check-input" />
                                                        <span>@_localizer["Використовувати авторський розв'язок на тесті"]</span>
                                                    </label>
                                                </div>

                                                @if (testInfo.RuntimeLimits != null)
                                                {
                                                    @* RuntimeLimits.MaxRealTime *@
                                                    <div class="form-floating mt-2">
                                                        <InputNumber @bind-Value="@testInfo.RuntimeLimits.MaxRealTime" class="form-control"/>
                                                        <label>@_localizer["Обмеження астрономічного часу ({0})", nameof(testInfo.RuntimeLimits.MaxRealTime)]</label>
                                                        <div class="form-text">@_localizer["Вкажіть максимальний астрономічний час виконання програми користувача у мілісекундах, після вичерпання якого процес примусово завершує свою роботу."]</div>
                                                    </div>
                                                    @* /RuntimeLimits.MaxRealTime *@
                                                    
                                                    @* RuntimeLimits.MaxProcessorTime *@
                                                    <div class="form-floating mt-2">
                                                        <InputNumber @bind-Value="@testInfo.RuntimeLimits.MaxProcessorTime" class="form-control"/>
                                                        <label>@_localizer["Обмеження процесорного часу ({0})", nameof(testInfo.RuntimeLimits.MaxProcessorTime)]</label>
                                                        <div class="form-text">@_localizer["Вкажіть максимальний процесорний час виконання програми користувача у мілісекундах, після вичерпання якого процес примусово завершує свою роботу."]</div>
                                                    </div>
                                                    @* /RuntimeLimits.MaxProcessorTime *@
                                                    
                                                    @* RuntimeLimits.PeakWorkingSet *@
                                                    <div class="form-floating mt-2">
                                                        <InputNumber @bind-Value="@testInfo.RuntimeLimits.PeakWorkingSet" class="form-control"/>
                                                        <label>@_localizer["Обмеження використання пам'яті ({0})", nameof(testInfo.RuntimeLimits.PeakWorkingSet)]</label>
                                                        <div class="form-text">@_localizer["Вкажіть обмеження використання віртуальної пам'яті (working set) у байтах процесом, у випадку порушення якого процес примусово завершує свою роботу."]</div>
                                                    </div>
                                                    @* /RuntimeLimits.PeakWorkingSet *@
                                                }

                                                <div class="mt-2">
                                                    <button type="button" class="btn btn-outline-secondary" @onclick="(() => ToggleRuntimeLimitsOnTheTest(currentTestId - 1))">
                                                        <i class="fas fa-snowplow"></i>&nbsp;
                                                        @if (testInfo.RuntimeLimits == null)
                                                        {
                                                            <span>@_localizer["Встановити індивідуальні обмеження"]</span>
                                                        }
                                                        else
                                                        {
                                                            <span>@_localizer["Використовувати обмеження за замовчуванням"]</span>
                                                        }
                                                    </button>
                                                    <button type="button" class="btn btn-outline-danger" @onclick="(() => RemoveReleaseTest(currentTestId - 1))">
                                                        <i class="fas fa-times-circle"></i>
                                                        <span>@_localizer["Видалити тест"]</span>
                                                    </button>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                }
                            </div>
                        }
                        else
                        {
                            <div class="alert alert-dark">@_localizer["Жодного тесту ще не створено!"]</div>
                        }
                    </div>
                </div>
            </div>
            @* /ReleaseConfiguration *@

            <button type="submit" class="btn btn-lg btn-primary rounded-circle position-fixed shadow-lg" style="bottom: 20px; right: 20px; width: 50px; height: 50px; z-index: 1000;">
                <i class="fas fa-save"></i>
            </button>
        </EditForm>
    }
    
    @* Successful save alert *@
    @if (_showSuccessfulSaveAlert)
    {
        <div class="alert alert-dismissible alert-success rounded-0 position-fixed" style="bottom: 0; left: 0; right: 0; z-index: 1000;">
            <strong><i class="fas fa-check-circle"></i> <span>@_localizer["Зміни збережено!"]</span></strong> 
            @_localizer["Зміни, внесені вами у файл налаштувань, було успішно збережено."]
            <button type="button" class="btn-close" @onclick="(() => _showSuccessfulSaveAlert = !_showSuccessfulSaveAlert)"></button>
        </div>
    }
    @* /Successful save alert *@
</section>

<!--suppress CssUnusedSymbol -->
<style>
    div#configurationFileCodeEditor {
        margin: 0;
        font-size: 16px;
        background-color: #212121 !important;
    }
    
    div#configurationFileCodeEditor .ace_gutter {
        background: transparent !important;
    }
</style>

@code {
    private VerificationDataConfiguration _configuration;
    private bool _showSuccessfulSaveAlert = false;

    protected override async Task OnInitializedAsync()
    {
        try
        {
            _configuration = await _projectsOperator.CurrentProjectControl.GetVerificationDataConfigurationAsync();
        }
        catch (Exception ex)
        {
            Electron.Dialog.ShowErrorBox(ex.Source, ex.ToString());
        }
    }
    
    private async Task HandleValidSubmitAsync()
    {
        await _projectsOperator.CurrentProjectControl.SetVerificationDataConfigurationAsync(_configuration);
        StateHasChanged();
        _showSuccessfulSaveAlert = true;
    }

    private void HandleInvalidSubmit()
    {
        Electron.Dialog.ShowErrorBox(
            _localizer["ПОмилка у заповненні форми"],
            _localizer["Файл конфігурації не було збережено через допущену вами помилку при заповненні форми."]
        );
    }

    private void CreateNewReleaseTest()
    {
        _configuration.ReleaseConfiguration.Tests.Add(new SingleTestInfo
        {
            Title = _localizer["Новий тест"],
            RuntimeLimits = null
        });
    }

    private void RemoveReleaseTest(int testId)
    {
        _configuration.ReleaseConfiguration.Tests.RemoveAt(testId);
    }

    private void ToggleRuntimeLimitsOnTheTest(int testId)
    {
        _configuration.ReleaseConfiguration.Tests[testId].RuntimeLimits = (_configuration.ReleaseConfiguration.Tests[testId].RuntimeLimits == null)
            ? new RuntimeLimitsStore
            {
                MaxRealTime = _configuration.RuntimeLimits.MaxRealTime,
                MaxProcessorTime = _configuration.RuntimeLimits.MaxProcessorTime,
                PeakWorkingSet = _configuration.RuntimeLimits.PeakWorkingSet
            } : null;
    }

    private async Task ExecuteCreateAndOpenAsync(CreateObjectType objectType)
    {
        var relativePath = string.Empty;
        var isDirectory = false;

        switch (objectType)
        {
            case CreateObjectType.AuthorSolutionDirectory:
                isDirectory = true;
                relativePath = string.IsNullOrWhiteSpace(_configuration.AuthorSolution.SourceCodePath)
                    ? (_configuration.AuthorSolution.SourceCodePath = "author_solution")
                    : _configuration.AuthorSolution.SourceCodePath;
                break;
                
            case CreateObjectType.InitializerFile:
                relativePath = string.IsNullOrWhiteSpace(_configuration.TestLib.InitializerPath)
                    ? (_configuration.TestLib.InitializerPath = "testlib/initializer.cs")
                    : _configuration.TestLib.InitializerPath;
                break;
            case CreateObjectType.FinalizerFile:
                relativePath = string.IsNullOrWhiteSpace(_configuration.TestLib.FinalizerPath)
                    ? (_configuration.TestLib.FinalizerPath = "testlib/finalizer.cs")
                    : _configuration.TestLib.FinalizerPath;
                break;
                
            case CreateObjectType.GeneratorFile:
                relativePath = string.IsNullOrWhiteSpace(_configuration.TestLib.GeneratorPath)
                    ? (_configuration.TestLib.GeneratorPath = "testlib/generator.cs")
                    : _configuration.TestLib.GeneratorPath;
                break;
                
            case CreateObjectType.CheckerFile:
                relativePath = string.IsNullOrWhiteSpace(_configuration.TestLib.CheckerPath)
                    ? (_configuration.TestLib.CheckerPath = "testlib/checker.cs")
                    : _configuration.TestLib.CheckerPath;
                break;
        }

        if (string.IsNullOrEmpty(relativePath))
            throw new NotImplementedException();

        var fullPath = Path.Combine(_projectsOperator.CurrentProjectControl.VerificationDataDirectoryPath, relativePath);

        if (isDirectory)
        {
            if (!Directory.Exists(fullPath))
                Directory.CreateDirectory(fullPath);
            
            await Electron.Shell.OpenPathAsync(fullPath);
        }
        else
        {
            if (!File.Exists(fullPath))
            {
                Directory.GetParent(fullPath)?.Create();
                await File.WriteAllTextAsync(fullPath, string.Empty, Encoding.UTF8);
            }
            
            await Electron.Shell.ShowItemInFolderAsync(fullPath);
        }
    }

    private enum CreateObjectType
    {
        AuthorSolutionDirectory,
        InitializerFile,
        FinalizerFile,
        GeneratorFile,
        CheckerFile
    }
}